c     ***********************************************************
      subroutine densenv(rad,rmin,thetin,costin,pi,pihalf,phi,dens)

c     calculates density in envelope. called during grid setup
c     so doesn't need to be optimized.

c  history:
c  00/09/06 (baw): write subroutine, modified from opacenv.f

      implicit none
      include 'opacin.txt' 
      real*8 rad,dens,cosa,rado,radi,rmin,phi,thet,thetin,pihalf,y,
     $     pi,r2,costin,m,n,fact,a,z,w,au
c     integer a

      au=1.4959787d13
c     testing 3-D stuff
      a=1.
      m=5.d0
      n=16.d0
      fact=((abs(cos(thetin*n)))**a)*((abs(cos(phi*m)))**a)
c     note that a=2 prevents negative values.  could also use abs function
c     to do 2-D stuff

c     set for 2-D
      fact=1.d0

c     for now, assuming +z = -z
      thet=thetin
      cosa=abs(costin)
      if (thet.gt.pihalf) thet=pi-thet
      rado=2.d0*rmaxe    !set outside of bounds initially

      if (GEOM.eq.'davi') then
c     model given in units of arcsec, assumes d=2250 pc.
c     our units are cm, divide by 'au' to get z(au), divide by distance
c     to get z('').
         z=rad*cosa/au/2250.
         if (z.lt.6.5d0) then
            w=4.25d0-0.14d0*(6.5d0-z)**1.7
         else
            w=4.25*dsqrt(1.d0-0.11d0*(z-6.5d0)**2)
         endif
c     convert back to cm for rado.
         rado=2250.d0*au*dsqrt(w**2+z**2)
      endif

      if (GEOM.eq.'bub') then
         rado=rmaxe*cosa**ebub
      endif

      if (GEOM.eq.'sph') then
         rado=rmaxe
      endif
	
      if (GEOM.eq.'hour') then
         if (thet.gt.thetcut) then
c     x=thet/thetcut
            y=(thetcut-thet)
            r2=1.d0/coscut*exp(3.d0*y)
         else
            r2=1.d0/cosa
         endif
         rado=0.5*(r2+cosa**3)*rmaxe
      endif

      radi=rado*(1.d0-thick)
      if(rad.lt.rado.and.rad.gt.rmine) then
         if(rad.lt.radi) then
            dens=rho1/(rad/rmin)**er1
         else
            dens=rho2/(rad/rmin)**er2*fact
         end if
      else
         dens=0.
      endif

      if (GEOM.eq.'cap') then
         if (thet.le.thetcap1) then
            rado=0.5*(cosa**2+1.d0/cosa)*rmaxe
            radi=rado*(1.d0-thick)
            if(rad.lt.rado.and.rad.gt.rmine) then
               if(rad.lt.radi) then
                  dens=rho1/(rad/rmin)**er1
               else
                  dens=rho2/(rad/rmin)**er2*fact
               end if
            else
               dens=0.
            endif
         endif
         if (thet.le.(thetcap2).and.thet.gt.thetcap1) then
            rado=0.5*(cosa**2+1.d0/cosa)*rmaxe
            if (rad.lt.rado.and.rad.gt.rmine) then
               dens=rho2/(rad/rmin)**er2*fact
            else
               dens=0.d0
            endif
         endif
         if (thet.gt.(thetcap2)) then
            dens=0.d0
         endif
      endif
         
      return 
      end

