c     *********************************************************

      subroutine propagate(iphot,xmax,fractx,fractxh,dum,count2
     1     ,eps)

      implicit none

      include 'stokes.txt'
      include 'ds.txt'
      include 'opacin.txt'
      include 'taunum.txt'
      include 'random.txt'

      real*8 xran,xpold,ypold,rpold,rhopold,zpold,x,y,xmax,fractx
     1   ,sipold,tsum,pol2,thet,fractxh,eps,rhosq
      real ran2
      integer ii(3),dum(3),iphot,iscat,k,ia,ithet,ix,iy
     1   ,icount,i,ir,it,ip,count2

c     print*, 'in propagate, xp,yp,zp ',xp,yp,zp
c     print*, 'ux,uy,uz ',ux,uy,uz
      xpold=xp
      ypold=yp
      zpold=zp
      do i=1,3
         ii(i)=dum(i)
c     print*,'ii ',ii(i)
      enddo

c     iflag is set to 1 if photon scatters
      iflag=0
      exitflag=0
      aflag=0
      iscat=0

c     sample tau
      xran=ran2(i1)
      tau=-dlog(xran)	
c     integrate over distance until the optical depth equals tau.
      call tauint(iphot,tsum,ii,r2p,eps)
      if(exitflag.eq.1) go to 300
         if(aflag.eq.1) then
            write(6,*) 'shouldnt be here, aflag=1'
            count2=count2+1
            go to 400
         end if
      tot=tot+1.d0

c     photon scatters until exits disk
30    continue
         iflag=1
         sip=sip*rlam
         sqp=sqp*rlam
         sup=sup*rlam
         svp=svp*rlam
c     xran=ran2(i1)
c     if(xran.le.rlam) then

         iscat=iscat+1
         if (sip.lt.(1.0d-3*rlam)) then
            aflux=aflux+1
            go to 400
         endif
         sipold=sip
         if (ipeel.eq.1) then
            call peeloff(xp,yp,zp,sip,sqp,sup,svp
     1           ,cost,sint,cosp,sinp,phi
     1           ,pi,r2p,hit,htot,rsq,rtot
     1           ,peak,tsum,fractxh,ii,idust,iflag,iphot,eps)
         endif

c     pol2=sqp**2+sup**2+svp**2
c     if (pol2 .gt. sip**2) then
c     print*,'error, P^2, I^2 ', pol2,sip**2
c     continue
c     endif

c        xran=ran2(i1)
c        if(xran.le.rlam) then
         if (idust.lt.2) then
            call stokes
         else
            call stokes6
         end if
         pol2=sqp**2+sup**2+svp**2
         if (pol2 .gt. sip**2*1.001) then
            print*,'error, P^2, I^2 ', pol2,sip**2
            continue
         endif
c            iscat=iscat+1
c         else
c           photon absorbed, reemitted at longer wavelengths which we won't
c           consider here
c           if(rlam.eq.1.) write(6,*)'error! rlam=1, yet photon absorbed'
c           aflux=aflux+1.
c           go to 400
c           call therm
c         end if
c        sample tau
         xran=ran2(i1)
         tau=-dlog(xran)
c        integrate distance until optical depth equals tau.
         xpold=xp
         ypold=yp
         zpold=zp
         ux=sint*cosp
         uy=sint*sinp
         uz=cost
         call tauint(iphot,tsum,ii,r2p,eps)
c     check stuff
         ir=ii(1)
         it=ii(2)
         ip=ii(3)
c     print*,'ir,it,ip after tau call ',ir,it,ip
c     rsq=xp**2+yp**2+zp**2
c     print*,'rsq,r2arr(i),r2arr(i+1)',rsq,r2arr(ir),r2arr(ir+1)
         
         if(exitflag.eq.1) go to 300
         if (aflag.eq.1) then
c     write(6,*) 'photon absorbed by star, iphot',iphot
            go to 400
         end if 
      go to 30

 300  continue
c     photon exits
c     bin angle
c     if binning in cos(thet)
c     k=int(float(nmu)*(1.d0-cost)/2.d0)+1
c     if binning in theta
      thet=dacos(cost)
      k=int(float(nmu)*thet/pi)+1
      if (k.lt.0.or.k.gt.nmu) then
         print*, 'cost binning error, k, nmu ',k,nmu
      endif

      x = ypold*cosp-xpold*sinp
      y = zpold*sini(k)-ypold*u(k)*sinp
     &     -xpold*u(k)*cosp

c     first, sum fluxes
      rhosq=(x**2+y**2)
      if (rhosq.lt.aperturesq(3)) then
c      rhopold=dsqrt(xpold**2+ypold**2+zpold**2)
c      if (rhopold.lt.aperture(3)) then
         flux=flux+1
         if (iflag.eq.1) then
            sflux=sflux+1
            nscat=nscat+iscat
         endif
      endif
      do ia=1,3
         if (rhosq.lt.aperturesq(ia)) then
            si(k,ia)=si(k,ia)+sip
            sq(k,ia)=sq(k,ia)+sqp
            su(k,ia)=su(k,ia)+sup
            sv(k,ia)=sv(k,ia)+svp
            si2(k,ia)=si2(k,ia)+sip*sip
            sq2(k,ia)=sq2(k,ia)+sqp*sqp
            su2(k,ia)=su2(k,ia)+sup*sup
            sv2(k,ia)=sv2(k,ia)+svp*svp
            nums(k,ia)=nums(k,ia)+1
            if (iflag.eq.1) then
               spi(k,ia)=spi(k,ia)+sip
               spq(k,ia)=spq(k,ia)+sqp
               spu(k,ia)=spu(k,ia)+sup
               spv(k,ia)=spv(k,ia)+svp
            end if
         end if
      end do
      
      ix=int((x+xmax)/fractx)+1
      iy=int((y+xmax)/fractx)+1
      if (ix.le.nx.and.iy.le.nx.and.ix.gt.0.and.iy.gt.0) then
         image(ix,iy,k)=image(ix,iy,k)+(sip)
         imagei(ix,iy,k)=imagei(ix,iy,k)+(sip)
         imageq(ix,iy,k)=imageq(ix,iy,k)+(sqp)
         imageu(ix,iy,k)=imageu(ix,iy,k)+(sup)
         imagev(ix,iy,k)=imagev(ix,iy,k)+(svp)
         image2(ix,iy,k)=image2(ix,iy,k)+sip*sip
         numi(ix,iy,k)=numi(ix,iy,k)+1
      else
         icount=icount+1
      endif
      
      if(iflag.eq.0) then
         star(k)=star(k)+sip
      end if

 400  continue
      return
      end


c     *********************************************************



