      subroutine setup(cfile1)

      implicit none

      include 'params.txt'      !where narr is assigned
      include 'ds.txt'
      include 'stokes.txt'
      include 'opacin.txt'
      include 'out.txt'
      include 'mrncoef.txt'
      include 'tab.txt'
      include 'tabl.txt'
      include 'grid.txt'

      character cfile*80,cfile1*80
      real*8 aperture1,aperture2,aperture3,d,kapd,wave
     1     ,thethour,dthet,taudisk90

      integer i,i1,ia,k,j

c     read in variables

c     eta car namelist.  for use with denseta.f and eta.par
c      namelist /input/ rmaxe,rmaxd,rmaxi
c     1     ,GEOM,ebub,thethour,thetcap1,thetcap2
c     1     ,thick,er1,er2
c     1     ,taumax0,rho1_2
c     1     ,b,a,taumax90,zmin,rmine,rmind,rstar
c     1     ,massc,np,iwrite,i1,limb
c     1     ,ithoms,idust,kapd,rlam,g,pl,pc,sc
c     $     ,cfile
c     1     ,rexp,texp
c     1     ,aperture1,aperture2,aperture3
c     1     ,thete,phie,ipeel

      namelist /input/ rmaxe,rmaxd,rmaxi
     1     ,rstar,limb
     1     ,er1,taumax0,rho_eq_pol,rmine
     1     ,b,a,taudisk90,zmin,rmind
     1     ,np,iwrite,i1
     1     ,idust,cfile
     1     ,kapd,rlam,g,pl
     1     ,aperture1,aperture2,aperture3
     1     ,thete,phie,ipeel,writeim
     1     ,rexp,texp
      open(unit=11,file='sphere.par',status='old')
      read(11,nml=input)
      close(11)

      cfile1=cfile
      taumax90=taudisk90

c     ellipsoidal density parameter (see Bjorkman & Wood 2001, eqn 22)
      f=sqrt(rho_eq_pol-1)

c     TO DO: get rid of occult option, for comparison to doofus methods
c     that can't occult star.  
      occult=1

c     constants
      rsol=6.9598d10
      msol=1.989d33
      au=1.4959787d13
      aflux=0.d0
      flux=0.d0
      sflux=0.d0

      aperturesq(1)=aperture1
      aperturesq(2)=aperture2
      aperturesq(3)=aperture3
      
c     convert units to cgs
c     rmin,zmin,rmind,rmine are input in units of rstar
c     rmaxe,rmaxd,rmaxi are input in units of AU
      rmin=rstar*rsol     !set rmin=rstar in cgs
      rminsq=rmin*rmin
      zmin=rstar*rsol*zmin
      rmind=rmind*rstar*rsol
      rmaxe=rmaxe*au
      rmaxd=rmaxd*au
      rmaxi=rmaxi*au
      rmine=rmine*rstar*rsol

      rmax=dmax1(rmaxe,rmaxd)
        
      kappa=kapd
      nelems=6
      if(idust.eq.0) then
         kappa=0.3
         pl=1.
         idust=0
      end if
      
      write(6,*) 'rmax,rmaxd,rmaxi,rmin,rmind,zmin'
      write(6,*) sngl(rmax),sngl(rmaxd),sngl(rmaxi),sngl(rmin),
     $     sngl(rmind),sngl(zmin)
      
      pi=4.d0*datan(1.d0)
      r2p=2.d0*pi
      g2=g**2
      if(g.eq.0.) isot=1
      hit=0.
      htot=0.

      coste=cos(thete*pi/180.d0)
      sinte=sin(thete*pi/180.d0)
      cospe=cos(phie*pi/180.d0)
      sinpe=sin(phie*pi/180.d0)

c     geometry constants for eta car geometry
      thetcut=pi/180.d0*thethour
      coscut=dcos(thetcut)
      thetcap1=thetcap1*pi/180.d0
      thetcap2=thetcap2*pi/180.d0
      
      if (idust.eq.0) then
c         peak=2.0
         peak=1.501d0
      else if (idust.eq.1) then
c     peak=1.01*(1.-g**2)/(1.+g**2-2*g)**1.5
c     if (peak.lt.2) peak=2. ! H-G s11 peak not correct.
c     Cornette & Shanks modified H-G function
         peak=1.501d0*(1.-g**2)/(2.+g**2)*2./(1.+g**2-2.*g)**1.5
      else if (idust.eq.2) then
         call reatab(cfile,rlam,kapd,wave)
         kappa=kapd
      else
         print*,'wrong, idust out of range'
         stop
      endif
      print*,'peak of scattering function ',peak
     
c     integrated flux polarization over diameter of aperture in arcseconds.
c     d is in AU.
      do ia=1,3
         write(6,*) 'aperture in AU (radius)',aperturesq(ia)
         aperturesq(ia)=aperturesq(ia)*au
         aperturesq(ia)=aperturesq(ia)**2
      end do
      
c     limb darkening = 0 for constant, 1 for eddington.
c     make new table if you want something else
      if (limb.eq.1) call table

c     set up disk parameters, such as density based on input mass
      call diskpar
      
c     set up angle array
c     if binning in cos(theta)
c     dmu=2.d0/(float(nmu))
c     if binning in theta
      dthet=pi/(float(nmu))
      do i=1,nmu
c     if binning in theta
         th(i)=dthet*(dfloat(i)-0.5d0)
         u(i)=cos(th(i))
c     if binning in mu
c     u(i)=1.d0-(dfloat(i)-0.5d0)*dmu
      sini(i)=sqrt(1.-u(i)**2)
c     print*,'u(i) ',u(i)
         print*,'thet(i) ',th(i)*180.d0/pi
      end do

c     initialize arrays
      do k=1,nmu
         star(k)=0.0d0
      end do

      do k=1,nmu
      do i=1,3
         si(k,i)=0.0d0
         sq(k,i)=0.0d0
         su(k,i)=0.0d0
         sv(k,i)=0.0d0
         si2(k,i)=0.0d0
         sq2(k,i)=0.0d0
         su2(k,i)=0.0d0
         sv2(k,i)=0.0d0
         nums(k,i)=0
         spi(k,i)=0.0d0
         spq(k,i)=0.0d0
         spu(k,i)=0.0d0
         spv(k,i)=0.0d0
      enddo
      enddo

      do i=1,nx
      do j=1,nx
      do k=1,nmu
         image(i,j,k)=0.0d0
         imagei(i,j,k)=0.0d0
         imageq(i,j,k)=0.0d0
         imageu(i,j,k)=0.0d0
         imagev(i,j,k)=0.0d0
         image2(i,j,k)=0.0d0
         numi(i,j,k)=0
      end do
      end do
      end do

      end
      

c     ********************************************************













